#
# spec file for package valgrind (Version 3.2.3)
#
# Copyright (c) 2008 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# usedforbuild    aaa_base acl attr audit-libs autoconf automake bash bind-libs bind-utils binutils bison brp-check-internal bzip2 coreutils cpio cpp cpp41 cracklib cvs cyrus-sasl db diffutils e2fsprogs expat file filesystem fillup findutils flex fontconfig fontconfig-devel freetype2 freetype2-devel gawk gcc gcc-c++ gcc41 gcc41-c++ gdbm gdbm-devel gettext gettext-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv klogd less libacl libattr libcom_err libgcc41 libltdl libmudflap41 libnscd libstdc++41 libstdc++41-devel libtool libvolume_id libxcrypt libzio linux-kernel-headers m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch perl permissions pkgconfig popt post-build-checks procinfo procps psmisc pwdutils rcs readline rpm sed strace sysvinit tar tcpd texinfo timezone unzip util-linux vim xorg-x11-devel xorg-x11-fonts-devel xorg-x11-libICE xorg-x11-libICE-devel xorg-x11-libSM xorg-x11-libSM-devel xorg-x11-libX11 xorg-x11-libX11-devel xorg-x11-libXau xorg-x11-libXau-devel xorg-x11-libXdmcp xorg-x11-libXdmcp-devel xorg-x11-libXext xorg-x11-libXext-devel xorg-x11-libXfixes xorg-x11-libXfixes-devel xorg-x11-libXmu xorg-x11-libXmu-devel xorg-x11-libXp xorg-x11-libXp-devel xorg-x11-libXpm xorg-x11-libXpm-devel xorg-x11-libXprintUtil xorg-x11-libXprintUtil-devel xorg-x11-libXrender xorg-x11-libXrender-devel xorg-x11-libXt xorg-x11-libXt-devel xorg-x11-libXv xorg-x11-libXv-devel xorg-x11-libfontenc xorg-x11-libfontenc-devel xorg-x11-libs xorg-x11-libxkbfile xorg-x11-libxkbfile-devel xorg-x11-proto-devel xorg-x11-util-devel xorg-x11-xtrans-devel zlib zlib-devel


Name:           valgrind
BuildRequires:  gcc-c++ xorg-x11-devel
%ifarch x86_64
%if %suse_version > 1010
BuildRequires:  gcc-32bit
%endif
%if %suse_version < 1010
BuildRequires:  gcc-32bit glibc-32bit
%endif
%endif
Url:            http://valgrind.org/
License:        GPL v2 or later
Group:          Development/Tools/Debuggers
Summary:        Memory Management Debugger
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Version:        3.2.3
Release:        17.3
Source0:        %{name}-%{version}.tar.bz2
# svn  di svn://svn.valgrind.org/valgrind/tags/VALGRIND_3_2_1 svn://svn.valgrind.org/valgrind/branches/VALGRIND_3_2_BRANCH > 3_2_BRANCH.diff
# svn  di svn://svn.valgrind.org/vex/tags/VEX_3_2_1 svn://svn.valgrind.org/vex/branches/VEX_3_2_BRANCH > VEX_3_2_BRANCH.diff
Patch3:         valgrind-6012.patch
Patch4:         openat-handling.diff
Patch5:         omega_RC_01.patch
Patch6:         putenv-wrapper.diff
Patch7:         cve-2008-4865.diff
Provides:       callgrind
Obsoletes:      callgrind
ExclusiveArch:  %ix86 x86_64 ppc ppc64

%description
Valgrind checks all memory operations in an application, like read,
write, malloc, new, free, and delete. Valgrind can find uses of
uninitialized memory, access to already freed memory, overflows,
illegal stack operations, memory leaks, and any illegal
new/malloc/free/delete commands. Another program in the package is
"cachegrind," a profiler based on the valgrind engine.

To use valgrind you should compile your application with "-g -O0"
compiler options. Afterwards you can use it with:

valgrind --tool=memcheck --sloppy-malloc=yes --leak-check=yes
--db-attach=yes my_application, for example.

More valgrind options can be listed via "valgrind --help". There is
also complete documentation in the /usr/share/doc/packages/valgrind/
directory. A debugged application runs slower and needs much more
memory, but is usually still usable. Valgrind is still in development,
but it has been successfully used to optimize several KDE applications.



Authors:
--------
    Julian Seward <jseward@acm.org>
    Cerion Armour-Brown
    Jeremy Fitzhardinge
    Tom Hughes
    Nicholas Nethercote
    Paul Mackerras
    Dirk Mueller
    Robert Walsh

%debug_package
%prep
%setup -q -n %{name}-%{version}
cd VEX
cd ..
%ifarch %ix86 x86_64
%patch5
%endif
%patch4
%patch6
%patch7

%build
export CFLAGS="$RPM_OPT_FLAGS"
export CXXFLAGS="$RPM_OPT_FLAGS"
autoreconf -fi
export GDB=/usr/bin/gdb
%configure
make %{?jobs:-j%jobs}

%install
make DESTDIR=$RPM_BUILD_ROOT install
mkdir -p $RPM_BUILD_ROOT/usr/share/doc/packages
mv $RPM_BUILD_ROOT/usr/share/doc/valgrind $RPM_BUILD_ROOT/usr/share/doc/packages

%files
%defattr(-,root,root)
%doc README* NEWS ACKNOWLEDGEMENTS AUTHORS COPYING
/usr/bin/*
/usr/include/valgrind
/usr/%_lib/pkgconfig/valgrind.pc
%_libdir/valgrind
%doc %_mandir/*/*

%changelog
* Thu Nov 20 2008 - dmueller@suse.de
- fix .valgrindrc reading vulnerability (CVE-2008-4865, bnc#445013)
* Fri Mar 30 2007 - dmueller@suse.de
- add patch to track undefinedness in environment (#249676)
* Tue Jan 30 2007 - dmueller@suse.de
- update to 3.2.3:
  * fixes two serious regressions introduced in 3.2.2
  * intercept stpcpy_chk (#234247)
- fix openat syscall wrapper (#240225)
* Thu Jan 25 2007 - dmueller@suse.de
- intercept stpcpy_chk and memrchr as well (#234347)
* Tue Jan 23 2007 - dmueller@suse.de
- switch to gcc-32bit on x86_64
* Mon Jan 22 2007 - dmueller@suse.de
- update to 3.2.2:
  * many fixes for ppc 32/64 (#fate 301640)
* Tue Oct 17 2006 - dmueller@suse.de
- disable omega plugin for ppc/ppc64
* Mon Oct 16 2006 - dmueller@suse.de
- update to 3.2 BRANCH:
  * support glibc 2.5
  * update suppressions
- add omega plugin
* Sat Sep 16 2006 - dmueller@suse.de
- update to 3.2.1:
  * suppresion updates
* Fri Sep 15 2006 - dmueller@suse.de
- update to 3.2.1rc1:
  * about 36 bugfixes
* Wed Sep 13 2006 - stbinner@suse.de
- fix build with < Factory
* Mon Aug 28 2006 - dmueller@suse.de
- fix suppressions
- update drd plugin
* Thu Aug 24 2006 - dmueller@suse.de
- add experimental drd plugin
- fix build on x86_64
* Wed Aug 02 2006 - dmueller@suse.de
- also fix multibyte NOP parsing for x86_64
* Tue Aug 01 2006 - dmueller@suse.de
- add patch to handle multibyte NOPs as generated by
  recent binutils
* Wed Jun 07 2006 - dmueller@suse.de
- update to 3.2.0 final
  * only marginal changes since rc1
* Tue May 30 2006 - dmueller@suse.de
- update to 3.2.0 rc1:
  * ppc64 support
  * callgrind now integrated part
  * massive performance improvements
  * lots of emulation fixlets
* Thu Mar 16 2006 - dmueller@suse.de
- update to 3.1.1 (FATE #300493)
* Mon Mar 06 2006 - dmueller@suse.de
- various updates from branch to fix PPC32 support
* Mon Feb 06 2006 - dmueller@suse.de
- Fix GDB support
* Mon Feb 06 2006 - dmueller@suse.de
- Reduce BuildRequires
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Wed Jan 04 2006 - dmueller@suse.de
- update to 3.1 branch
* Fri Dec 09 2005 - dmueller@suse.de
- fix strict-aliasing issue
* Mon Nov 28 2005 - dmueller@suse.de
- 3.1.0 final update
* Mon Nov 21 2005 - dmueller@suse.de
- 3.1.0 RC1 update
* Thu Nov 10 2005 - dmueller@suse.de
- update to 3.1 SVN
* Tue Nov 08 2005 - dmueller@suse.de
- add hack to make valgrind work with apps that require executable stack
* Thu Sep 15 2005 - dmueller@suse.de
- update 3.0.1 final
* Thu Aug 25 2005 - dmueller@suse.de
- make massif work again
* Sun Aug 21 2005 - dmueller@suse.de
- fix trace-children=yes failure
- add default suppressions for SL 10
* Mon Aug 15 2005 - dmueller@suse.de
- regenerate VEX offset headers, otherwise it just hangs
* Fri Aug 12 2005 - dmueller@suse.de
- update to 3.0 branch to make it work on non-SSE platforms (#104181)
* Fri Aug 05 2005 - dmueller@suse.de
- initial package of 3.0
